\version "2.24.0"
%%%%%%%%%%%%%%       MAKROS        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%  Titelseite

#(define-markup-command (vorschub layout props amount) (number?)
  (interpret-markup layout props
  (markup #:with-dimensions (cons 0 0) (cons 0 amount) #:null)))

st = ^\staccatissimo

%  Unterbalken geändert: statt 3 * 2 16-tel nun 2 * 3 16-tel
qbeam = {
  \set subdivideBeams = ##t
  \set Staff.beatLength = #(ly:make-moment 3 16)
  \set Staff.beatLength = #(ly:make-moment 3 8)
}
% Unterbalken gemäß Standard
nbeam = {
  \set Staff.beatLength = #(ly:make-moment 1 8)
  \set subdivideBeams = ##f
}
% Linien im Generalbass ein und ausschalten
lj = \set useBassFigureExtenders = ##t
ln = \set useBassFigureExtenders = ##f


% bei Verzierungen: Hälse kürzen, Hals nach unten, kleine Noten
sk =  { \once \override Stem.length-fraction = #0.6 \once \override Stem.direction = #DOWN \once \set fontSize = #-4   }
ska = { \once \override Stem.length-fraction = #0.7 \once \override Stem.direction = #DOWN \once \set fontSize = #-4   }
sku = { \once \override Stem.length-fraction = #0.7 \once \override Stem.direction = #UP \once \set fontSize = #-4   }
skn = { \once \override Stem.length-fraction = #1 \once \override Stem.direction = #DOWN \once \set fontSize = #-4   }
sn =     \override Stem.length-fraction = #1  %normale Länge

% Nötig für weiße Notenköpfe
dua = \override NoteHead.duration-log = #1
duo = \override NoteHead.duration-log = #0

tr = \trill
%tr = ^\markup  { \bold {+}}
pad =  { \once \override Script.padding = #1.0 }
% kleine Noten
kl =  \set fontSize = #-4 
  
% normal große Noten
nm =   \set fontSize = #0

% bei Verzierungen: Hälse kürzen, Hals nach unten, kleine Noten
skd =  { \once \override Stem.length-fraction = #0.6 \once \override Stem.direction = #DOWN \once \set fontSize = #-3   }
skxd =  { \override Stem.length-fraction = #0.4  \override Stem.direction = #DOWN  \set fontSize = #-3   }
skad = { \once \override Stem.length-fraction = #0.65 \once \override Stem.direction = #DOWN \once \set fontSize = #-3   }
sknd = { \once \override Stem.length-fraction = #1 \once \override Stem.direction = #DOWN \once \set fontSize = #-3   }
sku = { \once \override Stem.length-fraction = #0.6 \once \override Stem.direction = #UP \once \set fontSize = #-3   }
skau = { \once \override Stem.length-fraction = #0.65 \once \override Stem.direction = #UP \once \set fontSize = #-3   }
sknu = { \once \override Stem.length-fraction = #1 \once \override Stem.direction = #UP \once \set fontSize = #-3   }

% verkleinertes System
sstaffa = \with {
        	fontSize = #-3
        	\override StaffSymbol.staff-space = #(magstep -3)
        	\override StaffSymbol.thickness = #(magstep -3)
                % \override StaffGrouper.staffgroup-staff-spacing.basic-distance = #10
                 \override VerticalAxisGroup.staff-staff-spacing = #'((basic-distance . 11))
}
sstaffb = \with {
        	fontSize = #-3
        	\override StaffSymbol.staff-space = #(magstep -3)
        	\override StaffSymbol.thickness = #(magstep -3)
                \override VerticalAxisGroup.staff-staff-spacing = #'((basic-distance . 11))
}
sstaffc = \with {
        	fontSize = #-3
        	\override StaffSymbol.staff-space = #(magstep -3)
        	\override StaffSymbol.thickness = #(magstep -3)
                \override VerticalAxisGroup.staff-staff-spacing = #'((basic-distance . 15))
}
      


%%%%%%%%%%  This provides joint rests
%%%%%%%%%%  for the voices of the right hand in the realisation
%%%%%%%%%%  of the figured bass
#(define (rest-score r)
   (let ((score 0)
         (yoff (ly:grob-property-data r 'Y-offset))
         (sp (ly:grob-property-data r 'staff-position)))
     (if (number? yoff)
         (set! score (+ score 2))
         (if (eq? yoff 'calculation-in-progress)
             (set! score (- score 3))))
     (and (number? sp)
          (<= 0 2 sp)
          (set! score (+ score 2))
          (set! score (- score (abs (- 1 sp)))))
     score))

#(define (merge-rests-on-positioning grob)
   (let* ((can-merge #f)
          (elts (ly:grob-object grob 'elements))
          (num-elts (and (ly:grob-array? elts)
                         (ly:grob-array-length elts)))
          (two-voice? (= num-elts 2)))
     (if two-voice?
         (let* ((v1-grob (ly:grob-array-ref elts 0))
                (v2-grob (ly:grob-array-ref elts 1))
                (v1-rest (ly:grob-object v1-grob 'rest))
                (v2-rest (ly:grob-object v2-grob 'rest)))
           (and
            (ly:grob? v1-rest)
            (ly:grob? v2-rest)
            (let* ((v1-duration-log (ly:grob-property v1-rest 'duration-log))
                   (v2-duration-log (ly:grob-property v2-rest 'duration-log))
                   (v1-dot (ly:grob-object v1-rest 'dot))
                   (v2-dot (ly:grob-object v2-rest 'dot))
                   (v1-dot-count (and (ly:grob? v1-dot)
                                      (ly:grob-property v1-dot 'dot-count -1)))
                   (v2-dot-count (and (ly:grob? v2-dot)
                                      (ly:grob-property v2-dot 'dot-count -1))))
              (set! can-merge
                    (and
                     (number? v1-duration-log)
                     (number? v2-duration-log)
                     (= v1-duration-log v2-duration-log)
                     (eq? v1-dot-count v2-dot-count)))
              (if can-merge
                  ;; keep the rest that looks best:
                  (let* ((keep-v1? (>= (rest-score v1-rest)
                                       (rest-score v2-rest)))
                         (rest-to-keep (if keep-v1? v1-rest v2-rest))
                         (dot-to-kill (if keep-v1? v2-dot v1-dot)))
                    ;; uncomment if you're curious of which rest was chosen:
                    ;;(ly:grob-set-property! v1-rest 'color green)
                    ;;(ly:grob-set-property! v2-rest 'color blue)
                    (ly:grob-suicide! (if keep-v1? v2-rest v1-rest))
                    (if (ly:grob? dot-to-kill)
                        (ly:grob-suicide! dot-to-kill))
                    (ly:grob-set-property! rest-to-keep 'direction 0)
                    (ly:rest::y-offset-callback rest-to-keep)))))))
     (if can-merge
         #t
         (ly:rest-collision::calc-positioning-done grob))))


%{
convert-ly (GNU LilyPond) 2.24.1  convert-ly: »« wird verarbeitet...
Anwenden der Umwandlung: 2.19.2, 2.19.7, 2.19.11, 2.19.16, 2.19.22,
2.19.24, 2.19.28, 2.19.29, 2.19.32, 2.19.39, 2.19.40, 2.19.46,
2.19.49, 2.20.0, 2.21.0, 2.21.2, 2.22.0, 2.23.1, 2.23.2, 2.23.3,
2.23.4, 2.23.5, 2.23.6, 2.23.7, 2.23.8, 2.23.9, 2.23.10, 2.23.11,
2.23.12, 2.23.13, 2.23.14, 2.24.0
%}
